// A very simple demonstration of writing an animated GIF,
// starring everyone's favourite trig function.

import gifAnimation.*;

GifMaker maker;
int exp_frames;

int frames_per_cycle = 200;
int frame_number = 0;

void setup()
{
  size( 600, 200 );
  maker = null;
}

void draw()
{
  background( 220 );

  frame_number = (frame_number + 1) % frames_per_cycle;
  float time = (float(frame_number) / float(frames_per_cycle)) * TWO_PI;

  // Draw a sine wave across the screen.
  noFill();
  stroke( 0 );
  strokeWeight( 10.0 );
  strokeJoin( ROUND );
  beginShape();
  for ( int x = 0; x < 600; ++x ) {
    vertex( x, sin( x / 20.0 ) * 90 * sin( time ) + 100 );
  }
  endShape();

  // If we're currently in "write a GIF" mode,
  // add the current frame.
  if ( maker != null ) {
    // I believe setDelay operates in an integer number
    // of milliseconds -- how long to display the next frame
    // of the GIF when it's playing.  So set that to 
    // 1000ms/60, to approximate 60 frames per second.
    maker.setDelay( int( 1000.0 / 60.0 ) ); 
    // Add the current sketch window to the GIF.
    maker.addFrame();
    ++exp_frames;
    if ( exp_frames >= frames_per_cycle ) {
      maker.finish();
      maker = null;
      println( "Wrote " + exp_frames + " frames." );
    }
  }
}

void keyPressed()
{
  if ( key == 's' ) {
    maker = new GifMaker( this, "output.gif" );
    // Repeat forever.
    maker.setRepeat( 0 );
    exp_frames = 0;
  }
}

