// Kids today -- they don't know how good they have it.  Why,
// back when I was a kid, you occasionally had to adjust the
// "vertical hold" on a television, lest the picture continuously
// crawl up or down the screen.  Here's a quick hack to 
// simulate a TV with broken vertical hold.  I cut the screen out
// of a photo of an old TV and added a gradient and a layer of
// semi-transparent stripes, all of which is superimposed atop
// a moving still image from I Love Lucy.

// It would be pretty easy (and fun) to use a short video clip
// in place of a still image.  Have a look at the Movie class inside
// the Video library.

PImage lucy;
PImage console;
int retrace_interval = 20;
int y = 0;

void setup()
{
  size( 600, 450 );
  lucy = loadImage( "lucy.jpg" );
  console = loadImage( "television.png" );
}

void draw()
{
  background( 0 );
  
  // A cute way to get the appearance of continuous looping:
  // Always draw two copies of the image, and when you've moved
  // by exactly one image's height (plus a small, deliberate
  // gap), jump back down by the right amount.
  
  image( lucy, 0, y );
  image( lucy, 0, lucy.height + retrace_interval + y );

  y -= 5;
  if( y <= -420 ) {
    y = 0;
  }
  
  // The TV console image is bigger than the sketch, so use this
  // version of the image() function, which scales it to fit the
  // given rectangle.
  image( console, 0, 0, width, height );
}
